



@protocol AppControllerProtocol

- (id) masterClock;
- (id) compositor;
- (id) dataSourceController;
- (id) rootFolder;
- (id) fileLoader;
- (long) qtVersion;
- (id) oscManager;
- (id) midiManager;
- (id) pluginManager;
- (id) pageController;
- (id) SGController;

@end








@protocol PluginManagerProtocol

- (NSMutableArray *) pluginArray;
- (void) addTheseFilesToQueue:(NSArray *)a withParent:(id)p atIndex:(int)i isGridIndex:(BOOL)g;

@end








@protocol PageControllerProtocol

- (id) pageForUniqueId:(long)l;
- (id) fileAtIndex:(int)i onPage:(id)p;
- (void) deleteFilesWithIds:(NSArray *)a andReplaceWithBlankSpaces:(BOOL)r;
- (void) addBlankPage;
- (void) rdlock;
- (void) wrlock;
- (void) moveFilesWithIds:(NSArray *)a toPage:(id)p atIndex:(int)i andReplaceWithBlankSpaces:(BOOL)r;
- (void) recordVideoInputNamed:(NSString *)n toPageWithId:(long)p atIndex:(int)i;
- (void) addTapNamed:(NSString *)n toPageWithId:(long)p atIndex:(int)i;
- (void) closeGapAtIndex:(int)i onPageWithId:(long)p;
- (void) closeAllGapsOnPageWithId:(long)p;
- (void) copyFilesWithIds:(NSArray *)f toPage:(id)p atIndex:(int)i;
- (void) removePagesAtIndexes:(NSIndexSet *)a;
- (void) copyPagesAtIndexes:(NSIndexSet *)a to:(int)r;
- (void) movePagesAtIndexes:(NSIndexSet *)a to:(int)r;
- (void) insertPage:(id)p atIndex:(int)r;

@end






@protocol FileLoaderProtocol

- (void) loadWithOpenPanelToFolder:(id)f atIndex:(int)i isGridIndex:(BOOL)g;

@end






@protocol AppWindowMenuControllerProtocol

- (void) reloadMenuContents;
- (BOOL) interfaceLock;
- (BOOL) interfaceLockAll;
- (void) setLock:(BOOL)newLock andLockAll:(BOOL)newLockAll;

@end