//
//  BehaviorChainListController.h
//  VDMX
//
//  Created by bagheera on 5/16/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "BehaviorChainManager.h"
@class BehaviorChainManager;


@interface BehaviorChainListController : NSObject {
	IBOutlet NSTableView			*chainListTableView;
	IBOutlet NSTableColumn			*tableColumn;
	IBOutlet BehaviorChainWindow		*behaviorChainWindow;
	unsigned int					draggingRow;	//	i don't use the pboard for dragging fxwin -> fxwin; this is the row i'm dragging (may not be the selected row)
}

- (IBAction) createNewChain:(id)sender;
- (void) deleteKeyPressed;
- (IBAction) deleteSelectedChain:(id)sender;

- (void) tableViewSelectionDidChange:(NSNotification *)aNotification;
- (BOOL) selectionShouldChangeInTableView:(NSTableView *)aTableView;
- (void) listChangedNotificationMethod:(NSNotification *)notification;	//	called whenever the list of behavior chains changes...

- (int) numberOfRowsInTableView:(NSTableView *)aTableView;
- (id) tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)row;
- (void) tableView:(NSTableView *)aTableView setObjectValue:(id)anObject forTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;

//	this message is sent at the beginning of a drag operation
- (BOOL) tableView:(NSTableView *)tv writeRowsWithIndexes:(NSIndexSet *)rowIndexes toPasteboard:(NSPasteboard *)pboard;
- (void) pasteboard:(NSPasteboard *)sender provideDataForType:(NSString *)type;
//	this method i ssent when a drag operation enters my table
- (NSDragOperation)tableView:(NSTableView *)tableView validateDrop:(id <NSDraggingInfo>)info proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)operation;
- (BOOL) tableView:(NSTableView *)tableView acceptDrop:(id <NSDraggingInfo>)info row:(int)row dropOperation:(NSTableViewDropOperation)operation;

- (id) behaviorChainWindow;
- (unsigned int) draggingRow;

@end
