//
//  BehaviorChainManager.h
//  VVSliders
//
//  Created by bagheera on 2/8/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FXChainManager.h"
@class FXChainManager;
#import "BehaviorFXChain.h"
@class BehaviorFXChain;
#import "BehaviorChainWindow.h"
@class BehaviorChainWindow;
#import "BehaviorChainListController.h"
@class BehaviorChainListController;
#import "BehaviorCreationController.h"
@class BehaviorCreationController;
//#import "TheApplication.h"


@interface BehaviorChainManager : FXChainManager {
	//id							sliderController;
	NSMutableArray				*windArray;			//	array containing BehaviorChainWindow instances
	//ATSFontContainerRef			*loadedFontContainerRef;
	BOOL							frick;
	BOOL							frack;
	BOOL							frock;
}

//- (void) loadFontFromResources;
//	this method is called whenever a chain is added or removed, and sends a notification that any chain list views must be updated
//	this method has no worthwhile implementation in VVFXChainManager, because VVFXChainManager is a superclass
//	the subclasses of VVFXChainManager that represent each type of chain over-ride this method to post notifications
- (void) updateChainBasedLists;
//	this method sets  the sliderController var, so the behavior chain (really a chain manager) can point at the slider controller
//- (void) setSliderController:(id)newSliderController;
//- (id) sliderController;
- (IBAction) openANewWindow:(id)sender;

//	this method returns an array of NSMenuItems.  used for populating contextual menus.
- (NSMutableArray *) getBehaviorChainMenuItemArray;
- (BehaviorFXChain *) findBehaviorChainNamed:(NSString *)chainName;

//	this method remove a BehaviorChainWindow from the windArray.  it also closes and frees the window.
- (void) removeBehaviorChainWindow:(id)sender;
//	this method is called whenever a window is added or removed.  it goes through the windows in the windArray, and changes their windowTitles.
- (void) updateWindowNames;

- (void) readyToUse;		//	means that reg. passed, i can write files to disk

- (void) displayChainNamed:(NSString *)n;

//	load fx chain presets from the files on disk (load all of them, no matter what)
//- (void) loadFXChainPresetsFromDisk;
//	save fx chain presets to files on disk
//- (void) saveFXChainPresetsToDisk;
- (void) writeThisFXChainDictToDisk:(NSMutableDictionary *)d;
- (void) saveFXChainsToDisk;
- (void) loadFXChainsFromDisk;

- (NSMutableArray *) createSnapshot;
- (void) loadSnapshot:(NSMutableArray *)s;

- (NSMutableArray *)windArray;

@end
