//
//  BehaviorFXChain.h
//  VVSliders
//
//  Created by bagheera on 2/8/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "BehaviorChainManager.h"
@class BehaviorChainManager;
@class FXChain;
@class BehaviorChainWindow;


@interface BehaviorFXChain : FXChain {
	BehaviorChainWindow			*myBehaviorChainWindow;
	BOOL						evaluateConsistently;	//	if YES, must be evaluated every time the proc executes- like smooth
}

- (id) initWithParentManager:(FXChainManager *)newManager andBehaviorChainWindow:(BehaviorChainWindow *)parentWin;
- (BehaviorChainWindow *) myBehaviorChainWindow;
- (void) setMyBehaviorChainWindow:(BehaviorChainWindow *)newWindow;

- (void) loadSnapshot:(NSArray *)snap;

//- (void) saveThisChain;
//- (void) loadThisChainFromArray:(NSArray *)loadMe;
- (void) addEffectObject:(id)theObject;
- (id) returnNewEffectNamed:(NSString *)name;
- (IBAction) loadEffectNamed:(NSString *)name;
- (void) addEffectObject:(id)theObject;
- (void) insertEffectObject:(id)theObject intoChainAtIndex:(unsigned int)theIndex;
- (void) deleteThisEffect:(FXObject *)fxo;
- (void) deleteAllEffects;
- (void) updateEvaluateConsistently;

- (void) clearTrackingRects;	//	some behaviors have spline views, which need to reload their tracking rects for mouseovers
- (void) resetTrackingRects;

- (BOOL) evaluateConsistently;

@end
