


@protocol CompositorProtocol

- (void) lockForRender;
- (BOOL) tryLockForRender;
- (void) unlockRender;
- (void) drawContent;
- (CIImage *) clearImageWithSize:(CGSize)s;

- (NSMutableArray *) layerArray;
- (IBAction) deleteSelectedLayers:(id)sender;

- (void) moveTheseLayers:(NSMutableArray *)srcArray toIndex:(int)index ofLayer:(id)dstLayer;

- (long) getUniqueID;
- (void) uniqueIDRecovered:(long)p;

- (void) bumpUseSourceRes;

- (id) findLayerByName:(NSString *)n;

- (void) registerNewPreviewWindow:(id)n;
- (void) removeRegisteredPreviewWindow:(id)n;

- (NSMutableDictionary *) fontSynthPathsDict;
- (NSMenu *) fontSynthNamesMenu;

- (CVDisplayLinkRef) displayLink;
- (id) fullscreenToggle;
- (id) mainView;
- (NSPopUpButtonCell *) compTypeMenuCell;
- (NSMutableArray *) compFilterHumanNameArray;
- (NSMutableArray *) compFilterNameArray;
- (id) appController;
- (id) chainManager;
- (CIFormat) CIPixelFormat;

@end



@protocol CompositorGLViewProtocol

- (CIContext *) ciContext;
- (NSSize) canvasSize;
- (NSOpenGLContext *) sharedContext;

@end





