//
//  DataSource.h
//  NewDSCTest
//
//  Created by bagheera on 7/11/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <pthread.h>
//#import "DSCGlobals.h"
#import "DataSourceCall.h"



@interface DataSource : NSObject {
	int				sourceType;
	NSString			*sourceName;
	int				depth;			//	how many parents i have
	NSMutableArray	*fetchCalls;
	pthread_rwlock_t	fetchLock;			//	r/w lock around the fetchCalls
	DataSourceCall		*setCall;
	DataSource		*parentSource;		//	my parent data source (or nil)
	BOOL				needsToBePushed;	//	whether or not the DS has received a new value and it's fetch calls need to be pushed out
}

+ (long) DSCTime;
- (NSString *) description;
//	these two methods are used to format strings which describe the DSC-
//	for the 'description' method, and the 'description' method ONLY!
- (void) addObjectAtKey:(NSString *)s toDescriptionString:(NSMutableString *)m;
- (void) addTabsToMutString:(NSMutableString *)m;

+ (id) createWithName:(NSString *)n;
+ (id) createWithName:(NSString *)n ofType:(int)t;
+ (id) createWithName:(NSString *)name ofType:(int)type setByTarget:(id)target withAction:(SEL)action;

- (id) initWithName:(NSString *)n;
- (id) initWithName:(NSString *)n ofType:(int)t;

- (void) prepareToBeDeleted;

- (void) DSCProc;	//	when subclassing DataSource, call [super DSCProc] after you've set the value of the DS: this method pushes the value on to subscribers

- (void) addThisFetchCall:(id)f;
- (void) removeFetchCallForObject:(id)o;

- (NSMutableArray *) pathArray;
- (void) placePathInMutableArray:(NSMutableArray *)a;	//	only called from 'pathArray'!
- (BOOL) visibleInContextualMenu;
- (void) sendVisDepthToDSC:(id)dsc;

- (int) sourceType;
- (void) setSourceName:(NSString *)newName;		//	called set set the source name.  MUST NOT BE NIL.
- (NSString *) sourceName;
- (DataSource *) parentSource;
- (void) setParentSource:(DataSource *)np fromDSC:(id)dsc;
- (BOOL) needsToBePushed;
- (void) setNeedsToBePushed:(BOOL)n;
- (DataSourceCall *) setCall;
- (void) setSetCall:(DataSourceCall *)n;
- (int) depth;



@end
