//
//  DataSourceHolder.h
//  NewDSCTest
//
//  Created by bagheera on 7/11/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
#import "DataSource.h"





@interface DataSourceHolder : DataSource {
	pthread_rwlock_t		elementLock;
	//	keep in mind that the 'DataSource' superclass already has a sourceType and sourceName!
	NSMutableDictionary		*elementDict;	//	the dict which contains elements- elemts are other DataSources (or DataSourceHolders)
}

- (void) addObjectAtKey:(NSString *)s toDescriptionString:(NSMutableString *)m;	//	this method is used to format strings which describe the DSC

+ (id) createWithName:(NSString *)n;
+ (id) createWithName:(NSString *)n ofType:(int)t;

- (id) initWithName:(NSString *)n;
- (id) initWithName:(NSString *)n ofType:(int)t;
- (void) prepareToBeDeleted;

- (void) DSCProc;

- (DataSource *) dataSourceForKeyArray:(NSArray *)a;
- (DataSource *) dataSourceForValidMutableKeyArray:(NSMutableArray *)a;
- (int) elementDictCount;

- (void) safelyRemoveObjectForKey:(NSString *)k;		//	DOES NOT PREP FOR DELETION!  WARNING!
- (void) safelyInsertObject:(id)o forKey:(NSString *)k fromDSC:(id)dsc;

- (void) setParentSource:(DataSource *)np fromDSC:(id)dsc;

//- (NSMenu *) getDataSourcesMenuWithDSC:(id)dsc;
//- (NSArray *) getDataSourcesShallowMenuItems;
- (NSMutableArray *) extractMenuItemsMatchingMask:(long)mask toLevel:(int)level carryOverToLevel:(int)reset;
- (NSMutableArray *) extractMenuItemsToLevel:(int)level carryOverToLevel:(int)reset;
- (NSArray *) getDataSourcesMenuItems;
- (BOOL) visibleInContextualMenu;
- (void) sendVisDepthToDSC:(id)dsc;



@end
