//
//  FXChain.h
//  VVSliders
//
//  Created by bagheera on 2/8/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FXChainManager.h"
@class FXChainManager;
//#import "FXObject.h"
@class FXObject;
//#import "ShadowedClipView.h"
//@class ShadowedClipView;

@interface FXChain : NSObject {
	IBOutlet NSBox		*backgroundBox;
	IBOutlet NSView	*myView;
	
	NSString			*chainName;
	NSMutableArray	*fxArray;
	FXChainManager	*chainManager;
	
	NSScrollView		*parentScrollView;
}

- (id) initWithParentManager:(FXChainManager *)newManager andScrollView:(NSScrollView *)newScrollView;

- (void) windowDidLoad;
- (void) prepareToBeDeleted;

- (NSMutableArray *) createSnapshot;
- (void) loadSnapshot:(NSArray *)snap;

- (void) resizeChain;
- (void) setFXPositions;
- (void) updateMyView;

- (id) returnNewEffectNamed:(NSString *)name;
- (IBAction) loadEffectNamed:(NSString *)name;
- (void) addEffectObject:(id)theObject;
- (void) insertEffectObject:(id)theObject intoChainAtIndex:(unsigned int)theIndex;
- (void) insertEffectData:(NSData *)theData intoChainAtIndex:(unsigned int)theIndex;
- (void) deleteThisEffect:(FXObject *)del;
- (void) deleteEffectNamed:(NSString *)n;
- (void) deleteAllEffects;
- (FXObject *) fromEndFindEffectNamed:(NSString *)s;

//	this method passes a passed pointer (to whatever) through each successive item in the chain
- (void) passPtrThruChain:(id) passed;

- (NSString *)chainName;
- (void) setChainName:(NSString *)newName;
- (id) myView;
- (id) backgroundBox;
- (NSScrollView *) parentScrollView;
- (void) setParentScrollView:(NSScrollView *)newView;
- (FXChainManager *) chainManager;
- (NSMutableArray *) fxArray;

@end
