//
//  FXChainManager.h
//  VVSliders
//
//  Created by bagheera on 2/8/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
#import "FXChain.h"
@class FXChain;
#import "FXChainDragDestBox.h"
@class FXChainDragDestBox;
#import "FXObject.h"
@class FXObject;
#import "FXObjectPanel.h"
@class FXObjectPanel;
#import "VVRedView.h"
@class VVRedView;

@interface FXChainManager : NSObject {
	NSArray				*fxFolderPathArray;	//	stores path to relevant folder so i can load plugins/fx by name
	NSString				*fxFolder;			//	the folder that this chain manager will create from
	NSMutableDictionary		*fxClassDict;			//	stores the fx classes so the bundles only have to be loaded once
	//	these strings correspond to the relevant pasteboards for moving and copying both fx and chains with fx in them.
	NSString				*chainFXPboardType;	//	pboard type for dragging FX between and within chains of similar type
	NSString				*chainFXPboardName;
	NSString				*chainPboardType;		//	pboard type for dragging FX CHAINS between windows within this manager type
	NSString				*chainPboardName;
	NSMutableDictionary		*pluginResourceDict;	//	contains resources (images, etc.) shared by all fx, to save memory
	
	NSMutableArray		*fxChainPresetArray;	//	array holding dicts, each dict describes a saved chain preset- consists of a name, and the array which is the fx chain snapshot
}

//	this method sets the folder for the chain manager.  the folder is where the plugins are loaded from.
- (void) setFXFolder:(NSString *)newFXFolder;
//	this method loads the default imaging resources from the app bundle's resources.  this may be over-ridden to provide custom UI widgets standardized across a chain.
- (void) loadChainResources;

//	this method is called whenever a chain is added or removed, and sends a notification that any chain list views must be updated
//	this method has no worthwhile implementation in VVFXChainManager, because VVFXChainManager is a superclass
//	the subclasses of VVFXChainManager that represent each type of chain over-ride this method to post notifications
- (void) updateChainBasedLists;

- (Class) findClassForKey:(NSString *)aKey;
- (void) addClass:(Class)newClass toDictWithKey:(NSString *)akey;
- (id) returnNewEffectNamed:(NSString *)name;

- (NSArray *)fxFolderPathArray;

- (NSString *) chainFXPboardType;
- (NSString *) chainFXPboardName;
- (NSString *) chainPboardType;
- (NSString *) chainPboardName;
- (NSMutableDictionary *) pluginResourceDict;
- (NSMutableArray *) fxChainPresetArray;

- (NSMutableDictionary *) findPresetNamed:(NSString *)n;
- (BOOL) deletePresetNamed:(NSString *)n;
- (BOOL) deleteAllPresets;
- (NSMutableArray *) createSnapshot;
- (void) loadSnapshot:(NSArray *)s;

@end
