//
//  VVAudioDeviceThreadController.h
//  VVSliders
//
//  Created by David Lublin on 5/20/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

//	this is going to handle the running state of the various audio devices
//	pluggins that need to get audio from an audio device will subscribe to a device
//	and when the IOProc for that device is called, it'll pass the ABL to the pluggin


#import <Cocoa/Cocoa.h>
#import "VVAudioDeviceController.h"
@class VVAudioDeviceController;
#import "VVAudioPlugin.h"
@class VVAudioPlugin;
#import "davidsglobalkeys.h"


@interface VVAudioDeviceThreadController : NSObject {
	id							appController;
	
	NSString					*defaultInputDeviceName;
	NSString					*defaultOutputDeviceName;
	
	//NSMutableArray				*inputDeviceArray;		// this arrays will hold the input devices (of class VVAudioDeviceController)
	//NSMutableArray				*outputDeviceArray;		// this arrays will hold the output devices
	
	NSMutableDictionary			*inputDeviceDictionary;
	NSMutableDictionary			*outputDeviceDictionary;
}

- (id) initWithAppController:(id)new;
- (void) prepareToBeDeleted;
//- (NSArray *) prepareAudioDeviceList:(BOOL)isInput;
-(void) prepareAudioDeviceLists;
//- (void) prepareAudioDeviceList:(NSMutableArray *)deviceList:(BOOL)isInput;
- (void) audioDevicesDidChange;

- (void) newAudioPlugin:(NSNotification *)note;

- (void) subscribeMeToInput:(id)newSubscriber:(NSString *)deviceName;
- (void) subscribeMe:(id)newSubscriber:(NSString *)deviceName isInput:(BOOL)inputFlag;
- (void) unsubscribeMeFromInput:(id)subscriber;
- (void) unsubscribeMe:(id)subscriber isInput:(BOOL)inputFlag;

- (VVAudioDeviceController *) ptrToAudioDeviceNamed:(NSString *)deviceName;
- (VVAudioDeviceController *) ptrToAudioDeviceNamed:(NSString *)deviceName isInput:(BOOL)isInput;
- (VVAudioDeviceController *) ptrToAudioDeviceWithId:(AudioDeviceID) findMe;

- (NSDictionary *) inputDeviceDictionary;
- (NSDictionary *) outputDeviceDictionary;
- (NSString *) defaultInputDeviceName;
- (NSString *) defaultOutputDeviceName;
@end
