//
//  VVAudioPlugin.h
//  VVSliders
//
//  Created by David Lublin on 5/23/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

//	this is a sub-class of VVPlugin, with added methods and variables for dealing with
//	the VVAudioDeviceThreadController

#import <Cocoa/Cocoa.h>
#import "VVAudioDeviceThreadController.h"
@class VVAudioDeviceThreadController;
#import "VVAudioDeviceController.h"
@class VVAudioDeviceController;
//#import "VVPlugin.h"
//@class VVPlugin;
#import <VVEssentials/VVEssentials.h>
#import "davidsglobalkeys.h"

@interface VVAudioPlugin : VVPlugin {
	VVAudioDeviceThreadController	*audioDeviceThreadController;	//	ptr to the audio thread controller
	VVAudioDeviceController			*audioSource;	//	ptr to the device that I'm currently getting audio from
	VVAudioDeviceController			*audioDest;		//	ptr to the device that I'm sending audio to
	OSStatus						(*inputCallback)(AudioDeviceID, const AudioTimeStamp *, const AudioBufferList *, const AudioTimeStamp *, AudioBufferList *, const AudioTimeStamp *, void *);		//	function pointer to the actual plugin's subclass of VVAudioPlugin
	OSStatus						(*outputCallback)(AudioDeviceID, const AudioTimeStamp *, const AudioBufferList *, const AudioTimeStamp *, AudioBufferList *, const AudioTimeStamp *, void *);		//	function pointer to the actual plugin's subclass of VVAudioPlugin


}
- (void)setAudioDeviceThreadController:(VVAudioDeviceThreadController *)theThreadController;
- (void)setAudioSource:(VVAudioDeviceController *)newAudioSource;
- (void)setAudioDest:(VVAudioDeviceController *)newAudioDest;
- (VVAudioDeviceController *)audioSource;
- (VVAudioDeviceController *)audioDest;

@end


typedef struct	{
	@defs(VVAudioPlugin);
} AudioPluginStruct;


