//
//  VVButton.h
//  VDMX
//
//  Created by bagheera on 5/19/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVButtonManager.h"
@class VVButtonManager;
//#import "VVButtonCell.h"
//@class VVButtonCell;
#import "DataSourceController.h"
@class DataSourceController;
#import "GlobalKeys.h"

typedef enum _VVButtonType	{
	VVBClickButton = 0,			//	a mousedown triggers the button, moving the cursor out doesn't make it go up
	VVBToggleButton = 1			//	a mousedown triggers, button stays down until triggered again
} VVButtonType;

@interface VVButton : NSControl <VVSnapshotProtocol> {
	//BOOL					localFirstResponder;
	DataSourceController	*dataSourceController;
	BOOL					deleted;
}

+ (id) createWithFrame:(NSRect)f;
- (id) initWithFrame:(NSRect)r;

- (void) loadSnapshot:(NSDictionary *)fxDict;
- (void) loadSnapshot:(NSDictionary *)fxDict andOutput:(BOOL)o;

//	the slider's cell doesn't 'do' right-click (which is totally lame)
- (void) rightMouseDown:(NSEvent *)theEvent;
- (void) rightMouseDownTimer:(NSTimer *)timer;

- (void) setFrame:(NSRect)f;

//	sometimes a button is a data source; this is the method that sets a data source with the button's value
- (void) setDataSourceWithVal:(DataSource *)source;

- (void) hardwareLearnModeUpdated:(id)m;

- (void) lockThisButtonToMe:(id)lockToMe;
- (void) unlockMe;	//	unlocks anything- source button, non-source button....the works
- (NSMutableArray *) lockedButtonArray;
- (BOOL) hasLockedButtons;
- (id) lockedButtonSrc;
- (void) setLockedButtonSrc:(id)n;
- (BOOL) lockedFlag;
- (void) setLockedFlag:(BOOL)n;
- (BOOL) okayToTriggerLockedButtons;

- (int) buttonType;
- (void) setButtonType:(int)n;
/*
- (float) lineWidth;
- (void) setLineWidth:(float)n;
- (float) radius;
- (void) setRadius:(float)n;
- (NSColor *) bgColor;
- (void) setBgColor:(NSColor *)n;
- (NSColor *) bgColor2;
- (void) setBgColor2:(NSColor *)n;
- (NSColor *) bgColor3;
- (void) setBgColor3:(NSColor *)n;
- (NSColor *) strokeColor;
- (void) setStrokeColor:(NSColor *)n;
- (NSColor *) strokeColor2;
- (void) setStrokeColor2:(NSColor *)n;
- (NSColor *) strokeColor3;
- (void) setStrokeColor3:(NSColor *)n;
- (NSColor *) txtColor;
- (void) setTxtColor:(NSColor *)n;
- (NSColor *) txtColor2;
- (void) setTxtColor2:(NSColor *)n;
*/
- (NSString *) title;
- (void) setTitle:(NSString *)n;
- (NSString *) title2;
- (void) setTitle2:(NSString *)n;
//- (NSString *) fontName;
//- (void) setFontName:(NSString *)n;
//- (int) fontSize;
//- (void) setFontSize:(int)n;
//- (BOOL) state;
//- (void) setState:(BOOL)n;
- (void) setBoolValue:(BOOL)n;
- (void) setBoolValue:(BOOL)n andOutput:(BOOL)o;
- (int) intValue;
- (void) setIntValue:(int)n;
- (void) setIntValue:(int)n andOutput:(BOOL)o;
- (float) floatValue;
- (void) setFloatValue:(float)n;
- (void) setFloatValue:(float)n andOutput:(BOOL)o;
- (void) setState:(int)n;
- (void) setState:(int)n andOutput:(BOOL)o;
//- (NSString *) syncGen;
//- (NSString *) syncSpec;
- (NSArray *) syncArray;
- (BOOL) preventClickSelect;
- (void) setPreventClickSelect:(BOOL)n;
- (BOOL) triggerOnMain;
- (void) setTriggerOnMain:(BOOL)n;
- (NSNumber *) triggerOnMainNumber;
- (void) setTriggerOnMainNumber:(NSNumber *)n;
- (id) delegate;
- (void) setDelegate:(id)newDelegate;

- (void) useThisImageTile:(NSImage *)n withTileSize:(NSSize)s;

- (void) select;
- (void) deselect;
- (void) toggle;
- (void) bang;
- (void) mainThreadToggleMethod;
- (void) toggleRedrawMethod;

- (void) prepareToBeDeleted;

//	these methods are for saving/restoring the state of the UI object
//- (NSMutableDictionary *) createSnapshot;
//- (void) putUISnapshotInDict:(NSMutableDictionary *)fxDict;
//- (void) loadUISnapshotFromDict:(NSDictionary *)fxDict;

- (VVButtonManager *) buttonManager;
- (void) setButtonManager:(VVButtonManager *)n;
- (BOOL) syncFlag;
- (void) setSyncFlag:(BOOL)n;
- (float) threshVal;
- (void) setThreshVal:(float)n;
- (BOOL) triggerOnRise;
- (void) setTriggerOnRise:(BOOL)n;
- (BOOL) triggerOnFall;
- (void) setTriggerOnFall:(BOOL)n;
- (int) triggerMode;
- (void) setTriggerMode:(int)n;
- (int) modifiersOnClick;

- (BOOL) preventSyncToggle;
- (void) setPreventSyncToggle:(BOOL)n;
- (id) syncToggle;
- (void) setSyncToggleState:(BOOL)n;
- (id) syncToggleDict;
- (void) setSyncToggleDict:(id)n;

- (void) startMIDIDetect;
- (void) startOSCDetect;
- (void) startKeyDetect;
- (void) startButtonDetect;
- (void) stopMIDIDetect;
- (void) stopMIDIDetect;
- (void) stopKeyDetect;
- (void) stopButtonDetect;
//- (void) useThisSource:(NSString *)gen:(NSString *)spec;
- (BOOL) useThisSource:(NSArray *)a;
- (void) moveUp:(id)sender;
- (void) keyDown:(NSEvent *)event;
- (void) keyUp:(NSEvent *)event;

- (DataSourceController *) dataSourceController;
- (void) setDataSourceController:(DataSourceController *)n;

//	in some instances (specifically, in BlackTranslucentPanel), buttons need to be able to become the first responder
//- (void) setLocalFirstResponder:(BOOL)n;
- (BOOL) resignFirstResponder;
- (BOOL) becomeFirstResponder;
- (BOOL) acceptsFirstResponder;
- (BOOL) needsPanelToBecomeKey;


@end
