//
//  VVButtonManager.h
//  VDMX
//
//  Created by bagheera on 7/26/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
//#import "NSMutDictAdditions.h"
#import "VVButton.h"
@class VVButton;
#import "VVButtonCell.h"
@class VVButtonCell;
#import "DataSourceController.h"
@class DataSourceController;
#import "VVBMInterfaceManager.h"
@class VVBMInterfaceManager;

#import "VVBMSMCoordinator.h"
@class VVBMSMCoordinator;
#import "VVBMContextualMenuController.h"
@class VVBMContextualMenuController;
#import "VVBMDSListController.h"


@interface VVButtonManager : NSObject {
	IBOutlet VVBMSMCoordinator			*coordinator;	//	points to the object that controls the tab view for switching between button/slider view
	IBOutlet id							showShortcutButton;
	IBOutlet id							useValueButton;
	IBOutlet id							hardwareLearnButton;
	IBOutlet id							midiDetectButton;
	IBOutlet id							oscDetectButton;
	IBOutlet id							keyDetectButton;
	IBOutlet id							triggerOnFallButton;
	IBOutlet id							triggerOnRiseButton;
	IBOutlet id							triggerModeButton;
	IBOutlet id							showSyncToggleButton;
	IBOutlet VVBMContextualMenuController	*contextualMenuController;
	IBOutlet VVBMDSListController			*listController;
	//IBOutlet id						window;
	NSMutableArray					*selectedButtonArray;
	NSMutableArray					*buttonArray;
	IBOutlet id							appController;
	IBOutlet DataSourceController			*dataSourceController;
	IBOutlet VVBMInterfaceManager		*interfaceManager;
	
	BOOL								hardwareLearnMode;		//	whether or not hardware learn mode is active
	NSMutableDictionary					*appearanceDict;
}

- (void) putPaletteSnapInDict:(NSMutableDictionary *)snap;
- (void) matchThisPaletteShortcutSnapshot:(NSMutableDictionary *)snap;

- (void) selectThisButton:(VVButton *)n;		//	NEVER CALL THIS METHOD!  should only be called from the DSC!
//- (void) selectThisButtonToo:(VVButton *)n;
- (void) deselectAllButtons;				//	NEVER CALL THIS METHOD!  should only be called from the DSC!
- (void) deselectThisButton:(VVButton *)n;	//	NEVER CALL THIS METHOD!  should only be called from the DSC!

- (void) showShortcuts:(id)sender;
- (void) colorsUpdated;

- (void) deleteThisButton:(VVButton *)d;

- (void) newButtonNotification:(NSNotification *)note;
- (void) buttonManagerFinderNotification:(NSNotification *)note;

//- (BOOL) subscribeObject:(id)anObject selector:(SEL)theSelector toFetchSource:(NSString *)sourceCat:(NSString *)sourceName;
//- (void) subscribeObject:(id)anObject selector:(SEL)theSelector toSetSource:(NSString *)sourceCat:(NSString *)sourceName;
//- (void) unsubscribeObject:(id)anObject fetchingFrom:(NSString *)sourceCat:(NSString *)sourceName;
//- (void) unsubscribeObject:(id)anObject setting:(NSString *)sourceCat:(NSString *)sourceName;
//- (BOOL) sourceObject:(id)sourceObj withSelector:(SEL)sourceSel changeNameFrom:(NSString *)oldGen:(NSString *)oldSpec to:(NSString *)newGen:(NSString *)newSpec;

- (void) setSelectedButtonsSyncFlag:(BOOL)n;
- (void) setSelectedButtonsValThresh:(float)n;
- (void) setSelectedButtonsRiseToggle:(BOOL)n;
- (void) setSelectedButtonsFallToggle:(BOOL)n;
- (void) setSelectedButtonsTriggerMode:(int)n;
- (void) selectedButtonsStartMIDIDetect;
- (void) selectedButtonsStartOSCDetect;
- (void) selectedButtonsStartKeyDetect;
- (void) selectedButtonsUseThisSource:(NSArray *)a;
- (void) selectedButtonsSetSyncToggle:(BOOL)n;

- (VVBMInterfaceManager *)interfaceManager;
- (NSMutableArray *) selectedButtonArray;

//- (id) window;
- (VVBMSMCoordinator *) coordinator;

//	simply return the index of the category whose 'name' key corresponds to the passed cat name, or NSNotFound if not found
//- (int) indexOfCat:(NSString *) sourceCat;
//- (NSMutableDictionary *) findDataSourceCat:(NSString *)gen;
//- (NSMutableDictionary *) lockedFindDataSourceCat:(NSString *)gen;
//- (DataSource *) findDataSource:(NSString *)gen:(NSString *)spec;
//- (DataSource *) lockedFindDataSource:(NSString *)gen:(NSString *)spec;

//- (void) wasThisDataSourceDeletedOutFromUnderAnyButtons:(NSString *)g:(NSString *)s;
- (void) wasThisDataSourceDeletedOutFromUnderAnyButtons:(NSArray *)a;

- (void) reloadDSContextualMenu;
- (VVBMContextualMenuController *) contextualMenuController;
- (DataSourceController *) dataSourceController;
- (id) listController;
- (BOOL) hardwareLearnMode;
- (void) setHardwareLearnMode:(BOOL)n;
- (VVButton *) hardwareLearnButton;
- (NSMutableDictionary *) appearanceDict;
- (void) setAppearanceDict:(NSMutableDictionary *)n;

@end
