//
//  VVMIDIManager.h
//  VDMX
//
//  Created by bagheera on 4/20/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreMIDI/CoreMIDI.h>
#import "GlobalKeys.h"
#import "VVMIDIMsg.h"
//@class VVMIDIMsg;
#import "VVMIDIEndpoint.h"
//@class VVMIDIEndpoint;
#import "VVMIDISource.h"
//@class VVMIDISource;
#import "VVMIDIOutput.h"
//@class VVMIDIOutput;


#import "DataSourceController.h"
//@class DataSourceController;





@interface VVMIDIManager : NSObject {
	DataSourceController		*dataSourceController;
	id						appController;
	VVMIDISource				*virtualDestination;
	NSMutableArray			*midiSources;
	VVMIDIOutput				*output;
	NSMutableArray			*outputDeviceMenuItemArray;
	
	pthread_rwlock_t			pollLock;
	NSMutableArray			*pollArray;
	
	NSMutableDictionary			*dedicatedSourcesDict;
}

- (id) initWithAppController:(id)a;

- (void) loadMIDIInputSources;

- (void) setupChanged;
- (void) bang;

- (void) saveDedicatedToDefaults;
- (void) loadDedicatedFromDefaults;

- (void) registerForPollNotification:(NSNotification *)note;
- (void) unregisterForPollNotification:(NSNotification *)note;

- (VVMIDIOutput *)output;
- (NSMutableArray *) outputDeviceMenuItemArray;

- (NSMutableDictionary *) dedicatedSourcesDict;

//void MIDIChangedNotificationProc(const MIDINotification *msg, void *refCon);



@end
