//
//  VVMIDISource.h
//  MidiTestApp
//
//  Created by bagheera on 3/2/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreMIDI/CoreMIDI.h>
#import "GlobalKeys.h"
//#import "AppControllerProtocol.h"
#import "VVStatChecker.h"




@interface VVMIDISource : NSObject {
	MIDIEndpointRef			sourceEndpoint;
	NSMutableDictionary			*props;
	MIDIClientRef				client;
	MIDIPortRef				inPort;
	id						appController;
	//id						sliderManager;
	//NSNotificationQueue			*queue;
	NSString					*name;
	id						midiManager;
	BOOL						processingSysex;
	int						processingSysexSafetyCount;	//	only permits 128 cycles of the midi loop for sysex cmds
}
+ (id) createVirtualDestinationWithAppController:(id)newAppController;
- (id) initVirtualDestinationWithAppController:(id)newAppController;
+ (id) createWithSource:(MIDIEndpointRef)sourceRef andAppController:(id)newAppController;
- (id) initWithSource:(MIDIEndpointRef)sourceRef andAppController:(id)newAppController;

- (void) loadPropsFromEndpoint:(MIDIEndpointRef)sourceRef;

- (void) parsePacket:(MIDIPacket *)packet toArray:(NSMutableArray *)msgs;

- (NSMutableDictionary *)props;
- (id) appController;
- (NSString *) name;
- (void) setName:(NSString *)n;

//- (NSNotificationQueue *)queue;
//- (void) setQueue:(NSNotificationQueue *)new;
- (id) midiManager;
- (void) setMidiManager:(id)n;
- (BOOL) processingSysex;
- (int) processingSysexSafetyCount;

@end

//void fakeMIDIReadProc(const MIDIPacketList *pktList, void *readProcRefCon, void *srcConnRefCon);
void myMIDIReadProc(const MIDIPacketList *pktList, void *readProcRefCon, void *srcConnRefCon);
void myMIDINotificationProc(const MIDINotification *msg, void *refCon);
