//
//  VVOSCInPort.h
//  OSCtest
//
//  Created by bagheera on 10/11/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#import <pthread.h>
#import "VVOSCMessage.h"
#import "VVOSCBundle.h"





@interface VVOSCInPort : NSObject {
	BOOL					deleted;		//	whether or not i'm deleted- ensures that socket gets closed
	BOOL					bound;		//	whether or not the socket is bound
	int					sock;		//	socket file descriptor.  remember, everything in unix is files!
	struct sockaddr_in		addr;		//	struct that describes *my* address (this is an in port)
	short				port;			//	the port number i'm receiving from
	BOOL					running;		//	whether or not i should keep running
	BOOL					busy;
	char					buf[2049];	//	the socket gets data and dumps it here immediately
	
	pthread_mutex_t		lock;
	NSTimer				*threadTimer;
	int					threadTimerCount;
	NSAutoreleasePool		*threadPool;
	
	//NSMutableArray		*scratchArray;		//	this array's used to store temp objects in the threadProc
	NSMutableDictionary		*scratchDict;
	id					dataSourceController;
}

+ (id) createWithPort:(short)p andDSC:(id)d;
- (id) initWithPort:(short)p andDSC:(id)d;
- (void) prepareToBeDeleted;
- (BOOL) createSocket;
- (void) start;
- (void) stop;
- (void) launchOSCLoop:(id)o;
- (void) OSCThreadProc:(NSTimer *)t;
//- (NSArray *) getAndClearScratch;

- (short) port;
- (void) setPort:(short)n;
- (BOOL) bound;


@end
