//
//  VVOSCOutPort.h
//  VDMX
//
//  Created by bagheera on 10/19/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <sys/types.h>
#import <sys/socket.h>
#import <netinet/in.h>
#import <pthread.h>
#import "VVOSCMessage.h"
#import "VVOSCBundle.h"
#import "GlobalKeys.h"




@interface VVOSCOutPort : NSObject <VVSnapshotProtocol> {
	BOOL					deleted;
	int					sock;	//	the socket file descriptor i'm going to send to
	struct sockaddr_in		addr;	//	struct that describes the address i'm going to send to
	short				port;
	NSString				*addressString;
	NSString				*portLabel;
}

+ (id) createWithAddress:(NSString *)a andPort:(short)p andLabel:(NSString *)l;
- (id) initWithAddress:(NSString *)a andPort:(short)p andLabel:(NSString *)l;
- (BOOL) createSocket;

- (void) prepareToBeDeleted;

- (NSMutableDictionary *) createSnapshot;
- (void) loadSnapshot:(NSDictionary *) d;

//- (void) sendThisMessage:(VVOSCMessage *)m;
- (void) sendThisBundle:(VVOSCBundle *)b;

- (void) setAddressString:(NSString *)n;
- (void) setPort:(short)p;
- (void) setAddressString:(NSString *)n andPort:(short)p;

- (NSString *) addressString;
- (short) port;
- (NSString *) portLabel;
- (void) setPortLabel:(NSString *)n;

@end
