//
//  VVQuadraticSpline.h
//  VDMX
//
//  Created by David Lublin on 12/30/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>




@interface VVQuadraticSpline : NSObject <VVSnapshotProtocol> {
	NSPoint				cp[3];				//	start point, control point, end point.. control point is relative to start / end
	NSTrackingRectTag	trackingTags[3];	//	the tracking tags for each of the control points
	BOOL				useControlPoint;
}

+ (id) createFromDict:(NSMutableDictionary *)fxDict;
- (id) initFromDict:(NSMutableDictionary *)fxDict;

+ (id) createWithControlPoints:(NSPoint)cp0:(NSPoint)cp1:(NSPoint)cp2;
- (id) initWithControlPoints:(NSPoint)cp0:(NSPoint)cp1:(NSPoint)cp2;

//- (void)putUISnapshotInDict:(NSMutableDictionary *)fxDict;
//- (NSMutableDictionary *) createSnapshot;
//- (void)loadUISnapshotFromDict:(NSDictionary *)fxDict;

- (void) setControlPoint:(int)ptIndex:(NSPoint)newPoint;
- (NSPoint) getControlPointAtIndex:(int)index;

- (void) setTrackingPoint:(int)ptIndex:(NSTrackingRectTag)newTag;
- (NSTrackingRectTag) getTrackingPointAtIndex:(int)index;

- (BOOL) useControlPoint;
- (void) setUseControlPoint:(BOOL)val;



@end
