//
//  VVRTapStub.h
//  VVSliders
//
//  Created by bagheera on 4/13/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Quartz/Quartz.h>
#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
#import "LayerProtocol.h"
#import "CompositorProtocol.h"
#import "MutableTextureObject.h"
@class VVSTap;





@interface VVRTapStub : NSObject {
	id					tapManager;
	CIImageAccumulator		*accumulator;
	VVSTap				*sTap;
	CIImage				*lastSetImage;
	BOOL					preventLazyFail;
	BOOL					resetBounds;
	BOOL					leopardFlag;	//	on pre-10.5 systems, CIImageAccumulators don't have a 'clear' method
}

+ createStubWithTapManager:(id)manager andSTap:(id)newSTap;
- (id) initWithTapManager:(id)manager andSTap:(id)newSTap;

- (NSComparisonResult) layerDepthComparison:(VVRTapStub *)comp;

- (CIImage *) getCIImage;
- (MutableTextureObject *) getMutableTextureObject;
- (void) setCIImage:(CIImage *)newImage;
//	called when the canvas size changes, and the accumulator has to resize
-(void) updateAccumulatorSize;
//	when a layer's bounds (size/pos) change, the accumulator has to be cleared.  the layer calls this method when they change.
- (void) boundsChanged;
- (VVSTap *) sTap;
- (BOOL) preventLazyFail;
- (void) setPreventLazyFail:(BOOL)new;

@end
