//
//  VVSMContextualMenuController.h
//  VDMX
//
//  Created by bagheera on 11/10/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
#import "VVSliderManager.h"
@class VVSliderManager;
#import "DataSourceController.h"
@class DataSourceController;
//#import "TheApplication.h"



@interface VVSMContextualMenuController : NSObject {
	IBOutlet NSMenu				*sliderContextualMenu;
	IBOutlet NSMenuItem				*synchMenuItem;	//	the menu item that turns synching on/off
	IBOutlet NSMenuItem				*behaviorChainMenuItem;	//	the menu item that turns behavior chains on/off
	IBOutlet NSMenuItem				*lockUIMenuItem;	//	the menu item that locks the slider's UI
	
	IBOutlet NSMenuItem				*showSyncToggleItem;
	IBOutlet NSMenuItem				*showBehavToggleItem;
	
	IBOutlet NSMenuItem				*dataSourcesLabelItem;
	IBOutlet NSMenuItem				*behaviorChainsLabelItem;
	//NSMutableArray				*dataSourceMenuItems;	//	i maintain an array of menu items so they can be easily deleted, and i don't have to put them all in a submenu (which reduces usability)
	NSMutableArray				*behaviorChainMenuItems;	//	ditto for above...
	IBOutlet VVSliderManager			*sliderManager;
	IBOutlet DataSourceController		*dataSourceController;
	
	//ATSFontContainerRef			*loadedFontContainerRef;
}

//- (void) loadFontFromResources;
//	i am the delegate of the contextual menu that's displayed when the user ctrl-clicks on a slider
- (IBAction) sliderContextualMenuUsed:(id)sender;
- (IBAction) sliderCMDataSourceChosen:(id)sender;
- (IBAction) sliderCMBehaviorChainChosen:(id)sender;
- (void) reloadDSContextualMenu;		//	actually reloads the data sources in the menu
- (void) prepRawMenu:(NSMenu *)m;	//	sets the target/action for all the menu items and enables/disables them appropriately
- (void) reloadBCNotification:(NSNotification *)note;
- (void) reloadBCContextualMenu;

- (void) deselectAllDataSources;	//	un-checks all the data sources
- (void) deselectAllItemsInMenu:(NSMenu *)m;
- (void) selectDataSourceNamed:(NSString *)n;
- (BOOL) selectItemForSourceString:(NSString *)s inMenu:(NSMenu *)m;
- (void) deselectAllBehaviorChains;	//	un-checks all the behavior chains
- (void) selectBehaviorChainNamed:(NSString *)n;

- (NSMenu *) sliderContextualMenu;
- (NSMenuItem *) synchMenuItem;
- (NSMenuItem *) behaviorChainMenuItem;
- (NSMenuItem *) lockUIMenuItem;
- (NSMenuItem *) showSyncToggleItem;
- (NSMenuItem *) showBehavToggleItem;

@end
