//
//  VVSingleSpline.h
//  VDMX
//
//  Created by David Lublin on 1/12/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVQuadraticSpline.h"
//@class VVQuadraticSpline;
#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
//#import "TheApplication.h"
#import <pthread.h>


//	drag modes
#define VVSplineNoDragMask			0
#define VVSplineHandleDragMask		1
#define VVSplineShiftDragMask			2
#define VVSplineAmplitudeDragMask		3


@interface VVSingleSpline : NSObject <VVSnapshotProtocol> {
	BOOL					deleted;	//	turned to YES on prepareToBeDeleted
	NSMutableArray		*splineArray;
	pthread_mutex_t		splineLock;

	BOOL					useGLMode;

	NSBezierPath			*curvePath;
	NSBezierPath			*curveHandlesPath;
	NSBezierPath			*controlPointsPath;
	NSBezierPath			*highlightPath;
	NSBezierPath			*gridPath;
	
	NSPoint				lastEvalPoint;
	
	BOOL					optionOnClick;
	BOOL					cmdOnClick;
	BOOL					clickedOnCurve;
	
	VVQuadraticSpline		*clickedSpline;
	int					clickedPtIndex;		//	which of the points of the selectedSpline is clicked, 0 (start), 1 (cp), 2 (end point)
	NSPoint				startTrackingPt;
	
	int					handleRadius;
	
	NSRect				bounds;
	
	float					hOffset;			//	shifts the entire curve left/right
	float					vOffset;			//	shifts the entire curve up/down
	float					amplitude;
	
	float					hOffsetDragStart;
	float					vOffsetDragStart;
	float					amplitudeDragStart;
	
	float					snapDivisions;
	float					snapSensitivity;
	int					dragMode;
	
	NSView				*currentView;
	
	NSTrackingRectTag		handleMousedOverTag;
	NSCursor				*removeHandleCursor;
	NSCursor				*showControlPointCursor;
}

- (void) prepareToBeDeleted;

//- (void)putUISnapshotInDict:(NSMutableDictionary *)fxDict;
//- (NSMutableDictionary *) createSnapshot;
//- (void)loadUISnapshotFromDict:(NSDictionary *)fxDict;
- (void)saveWaveformToDiskWithName:(NSString *)waveformName;
- (void)loadWaveformFromDisk:(NSString *)waveformName;

- (void)prepareGridPath;
- (void)prepareCurvePath;
- (void)prepareTrackingRectsOnView:(NSView *)prepareMe;
- (void)clearTrackingRectsOnView:(NSView *)clearMe;

- (BOOL)handleClick:(NSPoint)clickLocation:(int)modifiers;
- (void)selectedPointMovedTo:(NSPoint)draggedPtLoc;
- (BOOL)handleMouseEnteredForTrackingRectTag:(NSEvent *)theEvent;
- (BOOL)handleFlagsChanged:(NSEvent *)theEvent;
- (BOOL)doCursorState:(NSTrackingRectTag)rectTag:(NSPoint)clickLocation:(int)modifiers;

- (float)evaluateAt:(float)x;
- (float)lockedEvaluateAt:(float)xInput;
- (BOOL)pointIsNearCurve:(NSPoint)thePoint;
- (float)snapValueToGrid:(float)snapMe;	

- (int)insertControlPointAtXLoc:(float)xInput;					//	returns index of new point, -1 if it fails
- (void)removeControlPointAtIndex:(int)removeMe;
- (void) removeAllControlPoints;
- (void) addControlPointAtXLoc:(float)newX YLoc:(float)newY;
- (void) setMagnitudeForPoint:(int)newIndex:(float)newMag;
- (void) setHandleForPoint:(int)newIndex:(NSPoint)newHandle;

- (NSMutableArray *)splineArray;
- (NSBezierPath *)curvePath;
- (NSBezierPath *)curveHandlesPath;
- (NSBezierPath *)controlPointsPath;
- (NSBezierPath *)gridPath;
- (NSPoint) lastEvalPoint;
- (void) setBounds:(NSRect) newBounds;
- (NSRect) bounds;
- (float) hOffset;
- (void) setHOffset:(float)newHOffset;
- (float) vOffset;
- (void) setVOffset:(float)newVOffset;
- (float) snapDivisions;
- (void) setSnapDivisions:(float)newDivisions;
- (float) amplitude;
- (void) setAmplitude:(float)newAmp;
- (int) dragMode;
- (void) setDragMode:(int)newDrag;
- (NSTrackingRectTag) handleMousedOverTag;
- (void) setHandleMousedOverTag:(NSTrackingRectTag)newTag;

- (BOOL) useGLMode;
- (void) setUseGLMode:(BOOL)n;
@end
