//
//  VVSingleSplineOpenGLView.h
//  VDMX
//
//  Created by David Lublin on 5/22/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/CGLMacro.h>
#import "VVSingleSpline.h"
#import "GlobalKeys.h"
#import "TheApplication.h"

@interface VVSingleSplineOpenGLView : NSOpenGLView <VVSnapshotProtocol> {
	VVSingleSpline				*theSpline;
	
	float						snapSensitivity;
	
	int		curvePointsCount;
	float		curvePoints[301];

	NSColor					*bgColor;
	NSColor					*curveFillColor;
	NSColor					*curveLineColor;
	NSColor					*controlPtLineDefaultColor;
	NSColor					*controlPtLineSelectedColor;
	NSColor					*handleRectDefaultColor;
	NSColor					*handleRectSelectedColor;
	NSColor					*snapLinesColor;
	NSColor					*startLineColor;
	
	NSPoint					lastPoint;
	
	NSTrackingRectTag			viewTrackingRectTag;
	BOOL						deleted;		//	set to YES on prepareToBeDeleted
	
	float	timeVal;
	float lastValue;
	
	GLfloat	levelViewWidth;
	
	BOOL		didResize;
}

- (void) prepareToBeDeleted;
- (float)evaluateAt:(float)x;
- (void) drawGridPath;
- (void)drawCurvePath;
- (void) prepareCurvePoints;
- (VVSingleSpline *)theSpline;

- (void) setTimeVal:(float)newTime;
- (float) timeVal;

- (void) forceRedrawNotification:(NSNotification *)note;

- (void) prepareTrackingRects;
- (void) clearTrackingRects;
- (void)resetCursorRects;
@end
