//
//  VVSliderManager.h
//  VDMX
//
//  Created by bagheera on 5/12/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <pthread.h>
#import "GlobalKeys.h"
//#import "NSMutDictAdditions.h"
#import "BehaviorChainManager.h"
//@class BehaviorChainManager;
//@class BehaviorFXChain;
//#import "VVMIDISource.h"
//@class VVMIDISource;
#import "DataSourceController.h"


#import "VVSliderControl.h"
#import "VVLogSliderControl.h"
//@class VVSliderControl;
//#import "VVSliderCell.h"
//@class VVSliderCell;
#import "VVSMDSListController.h"
@class VVSMDSListController;
#import "VVSMBehaviorListController.h"
@class VVSMBehaviorListController;
#import "VVSMInterfaceManager.h"
@class VVSMInterfaceManager;
#import "VVSMContextualMenuController.h"
@class VVSMContextualMenuController;

//#import "DataSourceController.h"
//@class DataSourceController;
//#import "DataSource.h"
//@class DataSource;

#import "VVBMSMCoordinator.h"
@class VVBMSMCoordinator;

//#import "CTGradient.h"
#import "TheApplication.h"





//	how the VVSliderManager keeps track of sources:
//	there is a 'sources' array (mutable)
//	each item in 'sources' is an NSMutableDictionary.  these are the categories.  categories have 2 keys:
//		'name'- the name of the category
//		'sourceArray'- an NSMutableArray that contains the actual 'DataSource' objects
//	the sources in 'sources' are strictly used for setting things every threadProc iteration
//	midi messages are sent intermittently, so it doesn't make sense to bang every detected message every iteration that hasn't been sent for a while
//	however, it *does* make sense to have a 'DataSource' object for every midi note/ctrl- even those that haven't been used in a while
//	for this reason, the 'VVDSMIDICat' has a bunch of sources, but the only displays the text 'MIDI detect'.  when a MIDI message is received,
//		it's added to a MIDI queue, and processed on the threadProc (run through MIDI queue, create DataSource if necessary/set DataSource)

@interface VVSliderManager : NSObject {
	IBOutlet VVBMSMCoordinator			*coordinator;	//	points to the object that controls the tab view for switching between slider/button view
	IBOutlet id							useValueButton;
	//IBOutlet id							hardwareLearnButton;
	IBOutlet id							midiDetectButton;
	IBOutlet id							useBehaviorButton;
	IBOutlet id							removeMarkButton;
	IBOutlet id							showSyncToggleButton;
	IBOutlet id							showBehavToggleButton;
	IBOutlet DataSourceController			*dataSourceController;
	IBOutlet VVSMDSListController			*listController;
	IBOutlet VVSMInterfaceManager		*interfaceManager;	//	this object manages everything pertaining to the interface
	IBOutlet VVSMContextualMenuController	*contextualMenuController;
	NSMutableDictionary					*sliderColorDict;	//	dict with keys representing slider situations; each key has a dict with actual colors at prop-name-keys
	//VVSliderCell						*sliderCell;
	pthread_mutex_t					sliderArrayLock;
	NSMutableArray					*sliderArray;
	NSMutableArray					*selectedSliderArray;
	long								idCount;
	NSImage							*lockIcon;
	BOOL								lockInterestingPoints;	//	whether or not interesting points are locked for editing by the user
	BOOL								hardwareLearnMode;		//	whether or not hardware learn mode is active
	
	//ATSFontContainerRef				*loadedFontContainerRef;
	
	BehaviorChainManager				*behaviorChainManager;	//	the behavior chain manager
	
	int								softTakeoverMode;		//	which mode is being used for soft takeover
	float								softTakeoverTolerance;	//	how close the DS val has to be to the last set value in order for takeover to happen
	float								softTakeoverSpeed;	//	how fast soft takeover moves
	
	//CTGradient						*selectedGradient;
	//CTGradient						*deselectedGradient;
	//CTGradient						*syncSelectedGradient;
	//CTGradient						*syncDeselectedGradient;
}

//- (void) loadFontFromResources;

- (void) putPaletteSnapInDict:(NSMutableDictionary *)snap;
- (void) matchThisPaletteShortcutSnapshot:(NSMutableDictionary *)snap;

//	when created, VVSliderControls post a notification so the manager can find them and init them
- (void) newSliderNotification:(NSNotification *)note;
//	called by the slider directly when it needs to be deleted
- (void) deleteThisSlider:(VVSliderCell *)del;
//	called by 'BehaviorChainListController' when a behavior's name is changed
- (void) behaviorNameChangedNotification:(NSNotification *)note;
//	called by 'BehaviorChainListController' when a behavior is being deleted
- (void) behaviorDeletedNotification:(NSNotification *)note;
//	called by anything that posts the 'find me' notification
- (void) sliderManagerFinderNotification:(NSNotification *)note;

//	when a data source is created, i have to run through all the sliders, and check to see if a slider whose data source was deleted out from under it can be re-synched to the newly created data source
//- (void) wasThisDataSourceDeletedOutFromUnderAnySliders:(NSString *)gen:(NSString *)spec;
- (void) wasThisDataSourceDeletedOutFromUnderAnySliders:(NSArray *)a;

//	called by the VVSMDSListController when the user selects a new source
//- (void) selectedSlidersUseThisSource:(NSString *)gen:(NSString *)spec;
- (void) selectedSlidersUseThisSource:(NSArray *)a;
//	called by VVSMInterfaceManager when user toggles the sync flag in the slider inspector
- (void) setSelectedSlidersSyncFlag:(BOOL)newValue;
//	called by the VVSMDSListController when the user selects the midi detect source
- (void) selectedSlidersStartMIDIDetect;
- (void) selectedSlidersStartOSCDetect;
//	called by the VVSMBehaviorListController when the user selects a new source
- (void) selectedSlidersUseThisBehavior:(BehaviorFXChain *)newBehavior;
- (BehaviorFXChain *) findBehaviorChainNamed:(NSString *)name;	//	called by VVSliderControl when it's finding a chain from a chain-name
//	called by VVSMInterfaceManager when the user toggles the behavior flag in the slider inspector
- (void) setSelectedSlidersBehaviorFlag:(BOOL)newValue;

- (void) reloadDSContextualMenu;		//	just tells the contextual menu manager to reload the menu...
- (void) colorsUpdated;

//	called by the DSC when a program change message is received from a midi source (so i can start soft takeover)
- (void) programChangeReceived;

//	called from the appcontroller when the prefs change some aspect of soft takeover
- (void) setSoftTakeoverMode:(int)n;
- (void) setSoftTakeoverTolerance:(float)n;
- (void) setSoftTakeoverSpeed:(float)n;

//	simply return the index of the category whose 'name' key corresponds to the passed cat name, or NSNotFound if not found
//- (int) indexOfCat:(NSString *) sourceCat;
//- (NSMutableDictionary *) findDataSourceCat:(NSString *)gen;
//- (NSMutableDictionary *) lockedFindDataSourceCat:(NSString *)gen;
//- (DataSource *) findDataSource:(NSString *)gen:(NSString *)spec;
//- (DataSource *) lockedFindDataSource:(NSString *)gen:(NSString *)spec;

- (VVSliderCell *) visibleSliderAtPoint:(NSPoint)p;

- (void) selectOnlyThisSlider:(VVSliderCell *)selectMe;	//	NEVER CALL THIS METHOD!  should only be called from the DSC!
- (void) selectThisSliderToo:(VVSliderCell *)selectMe;	//	NEVER CALL THIS METHOD!  should only be called from the DSC!
- (void) deselectThisSlider:(VVSliderCell *)deselectMe;	//	NEVER CALL THIS METHOD!  should only be called from the DSC!
- (void) deselectAllSliders;

- (void) selectedSlidersSetSyncToggle:(BOOL)n;
- (void) selectedSlidersSetBehavToggle:(BOOL)n;

//- (BOOL) subscribeObject:(id)anObject selector:(SEL)theSelector toFetchSource:(NSString *)sourceCat:(NSString *)sourceName;
//- (void) subscribeObject:(id)anObject selector:(SEL)theSelector toSetSource:(NSString *)sourceCat:(NSString *)sourceName;
//- (void) unsubscribeObject:(id)anObject fetchingFrom:(NSString *)sourceCat:(NSString *)sourceName;
//- (void) unsubscribeObject:(id)anObject setting:(NSString *)sourceCat:(NSString *)sourceName;
//- (BOOL) sourceObject:(id)sourceObj withSelector:(SEL)sourceSel changeNameFrom:(NSString *)oldGen:(NSString *)oldSpec to:(NSString *)newGen:(NSString *)newSpec;

- (void) evaluateContinuousBehaviors;	//	called by the DSC- some sliders may be using behaviors which require that the sliders be evaluated continuously (like smooth)

//	key-value (strict)
- (VVSMInterfaceManager *) interfaceManager;
- (NSMutableDictionary *) sliderColorDict;
- (void) setSliderColorDict:(NSMutableDictionary *)n;
- (NSMutableArray *) selectedSliderArray;
- (BehaviorChainManager *) behaviorChainManager;
- (VVBMSMCoordinator *) coordinator;
- (VVSMContextualMenuController *) contextualMenuController;
- (NSImage *) lockIcon;
- (DataSourceController *) dataSourceController;
- (id) listController;
- (BOOL) lockInterestingPoints;
- (void) setLockInterestingPoints:(BOOL)n;
- (BOOL) hardwareLearnMode;
- (void) setHardwareLearnMode:(BOOL)n;

/*
- (CTGradient *) selectedGradient;
- (CTGradient *) deselectedGradient;
- (CTGradient *) syncSelectedGradient;
- (CTGradient *) syncDeselectedGradient;
*/


@end
