//
//  VVTapManager.h
//  VVSliders
//
//  Created by bagheera on 4/13/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <pthread.h>
#import <Quartz/Quartz.h>

#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
#import "VVSTap.h"
@class VVSTap;
#import "VVRTap.h"
@class VVRTap;
#import "VVRTapStub.h"
@class VVRTapStub;
//#import "LayerWinRTapMenuController.h"
//@class LayerWinRTapMenuController;
#import "VVRTapMenuController.h"
//@class VVRTapMenuController;
#import "VVRTapLayerMenuController.h"
#import "VVRTapInputMenuController.h"
//#import "CITapElement.h"
//@class CITapElement;
//#import "TheApplication.h"


@interface VVTapManager : NSObject {
	pthread_mutex_t		drawingLock;
	id					compositor;
	NSMutableDictionary		*rTapDict;		//	each item has a key (name of sTap), the item is an NSMutableArray of rTaps
	NSMutableDictionary		*rTapStubDict;		//	each item has a key (name of sTap), the item is a stub (the actual accumulator)
	NSMutableDictionary		*sTapDict;
	
	NSMenu				*sortedSTapMenu;
	NSMenu				*sortedLayerSTapMenu;
	NSMenu				*sortedInputSTapMenu;
	NSDictionary			*fontAttribs;
	//ATSFontContainerRef	*loadedFontContainerRef;
	
	CIFilter				*clearColorGenerator;
}

- (id) initWithCompositor:(id)newComp;

//- (void) loadFontFromResources;

- (void) newTapNotification:(NSNotification *)note;

- (void) reloadTapsPostDict:(NSDictionary *)d;

- (void) sTapNameChangeFrom:(NSString *)oldName to:(NSString *)newName;

- (void) removeThisRTap:(VVRTap *) removeMe;
- (void) removeThisSTap:(VVSTap *) removeMe;

- (void) thisRTap:(VVRTap *)tap wantsToReceiveFrom:(NSString *)newTapName;

//	key-value
- (id) compositor;
- (NSDictionary *) fontAttribs;
- (NSMutableDictionary *) sTapDict;
- (NSMutableDictionary *) rTapDict;
- (NSMutableDictionary *) rTapStubDict;
- (NSMenu *) sortedSTapMenu;
- (NSMenu *) sortedLayerSTapMenu;
- (NSMenu *) sortedInputSTapMenu;
- (CIFilter *) clearColorGenerator;
- (void) lock;
- (void) unlock;


@end
