//
//  VVWindowContentView.h
//  VDMX
//
//  Created by bagheera on 5/10/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import "GlobalKeys.h"
#import "DataSourceController.h"
//@class DataSourceController;
//#import "VVButtonManager.h"
//@class VVButtonManager;
//#import "VVSliderManager.h"
//@class VVSliderManager;
//#import "AppWindowMenuController.h"
//@class AppWindowMenuController;
#import "VVWindow.h"
@class VVWindow;
//#import "VVPaletteWindow.h"
@class VVPaletteWindow;
//#import "VVWindowDelegateProtocol.h"
//#import "TheApplication.h"
//@class TheApplication;



@interface VVWindowContentView : NSView <VVSnapshotProtocol> {
	DataSourceController	*dataSourceController;
	id					buttonManager;
	id					sliderManager;
	id					menuController;
	BOOL					selected;
	NSRect				actualLocation;		//	the actual size of the object; changes with collapse/expand
	NSSize				expandedSize;		//	the size when expanded
	NSSize				minSize;			//	the minimum size; set on awakeFromNib:
	BOOL					collapsed;			//	whether or not i'm collapsed
	BOOL					allowResize;
	BOOL					resizePreserveAspect;	//	whether or not i preserve my aspect ratio on resize
	float					localAspectRatio;		//	width / height
	NSString				*objectName;
	NSDictionary			*titleFontAttribDict;
	
	BOOL					reRender;		//	if YES, then the paths get re-rendered in drawRect:
	BOOL					locked;		//	whether or not the window is locked
	BOOL					fullyLocked;	//	whether or not the window is fully locked (can't collapse/expand)
	NSBezierPath			*framePath;	//	the stroked/filled path around everything
	NSBezierPath			*titlePath;	//	the path of the bg of the title bar
	NSRect				collapseToggleRect;	//	the bounding rect of the toggle that collapses the box
	NSRect				resizeHandleRect;	//	the bounding rect of the resize handle
	//NSColor				*customLightColor;
	//NSColor				*customDarkColor;
	//NSColor				*customHighlightColor;
	
	//NSImage				*collapsedImage;
	//NSImage				*expandedImage;
	//NSImage				*resizeImage;
	NSBezierPath			*collapsedPath;
	NSBezierPath			*expandedPath;
	NSBezierPath			*resizePath;
	
	int					dragAction;	//	0=drag, 1=collapse/expand, 2=resize
	NSPoint				superClickLoc;	//	location in superview's coords of the mousedown, so i can calculate delta
	NSRect				clickFrame;	//	my frame on mousedown
	
	BOOL					affectedByChange;
	
	BOOL					cmdClick;		//	if i cmd-click on a window, it moves *just* the window- it doesn't drag other windows, too
	BOOL					optClick;		//	if i opt-click a window, it moves *all* adjacent windows
	
	NSImage				*bgImage;
	NSRect				bgImageRect;
}

- (void) moveWindowToDefaultLocation;

//- (void) setupWindowFromAttribDict:(NSDictionary *)attribs;
//- (void) putUISnapshotInDict:(NSMutableDictionary *)dict;
//- (NSMutableDictionary *) createSnapshot;
- (NSRect) convertBLScreenToTLScreen:(NSRect)c;
- (NSRect) convertTLScreenToBLScreen:(NSRect)c;

- (void) mouseDown:(NSEvent *)event;
- (void) mouseDragged:(NSEvent *)event;
- (void) mouseUp:(NSEvent *)event;

- (void) expand;
- (void) collapse;
- (void) moveWindowToHere:(NSRect)n;

//	notifications
- (void) windowLockedNotification:(NSNotification *)note;
- (void) dragSetupNotification:(NSNotification *)note;
- (void) calculateAffectedAreaNotification:(NSNotification *)note;
- (void) objectMoveNotification:(NSNotification *)note;
- (void) moveAffectedObjectsNotification:(NSNotification *)note;
- (void) windowSelectNotification:(NSNotification *)note;
- (void) windowSizePosReportNotification:(NSNotification *)note;
- (void) windowRedrawNotification:(NSNotification *) note;

//	first-responder stuff
- (BOOL) acceptsFirstResponder;
- (BOOL) resignFirstResponder;
- (BOOL) becomeFirstResponder;
- (void) keyDown:(NSEvent *)event;
- (void) keyUp:(NSEvent *)event;

//	internal
- (void) renderPaths;
//- (NSBezierPath *) roundRectPathInRect:(NSRect)rectFrame withRadius:(float)radius;
//- (NSBezierPath *) halfRoundRectPathInRect:(NSRect)rectFrame withRadius:(float)radius;
- (BOOL) wantsDefaultClipping;
- (void) setActualLocation:(NSRect)newLocation;
- (void) windowBecameKey;
- (void) setBgImage:(NSImage *)n;
- (NSColor *) backgroundColor;		//	these look like key-value methods, but they're not- at all
- (NSColor *) frameColor;
- (NSColor *) titleBarColor;
- (NSDictionary *) getRelevantColorDict;

//	this method over-rides the superclasses default behavior of the first click in a non-key window bringing the window to front
- (BOOL) acceptsFirstMouse:(NSEvent *)theEvent;
//- (BOOL) isOpaque;

//	key-value
- (NSRect) actualLocation;
- (int) dragAction;
- (void) setReRender:(BOOL)newVal;
- (NSString *) objectName;
- (void) setObjectName:(NSString *)n;
- (BOOL) collapsed;
- (NSSize) minSize;
- (void) setMinSize:(NSSize)n;
- (DataSourceController *) dataSourceController;
- (void) setDataSourceController:(DataSourceController *)n;
- (id) buttonManager;
- (void) setButtonManager:(id)n;
- (id) sliderManager;
- (void) setSliderManager:(id)n;
//- (void) setCustomLightColor:(NSColor *)c;
//- (void) setCustomDarkColor:(NSColor *)c;
//- (void) setCustomHighlightColor:(NSColor *)c;
- (void) setAllowResize:(BOOL)n;
- (BOOL) cmdClick;
- (id) menuController;
- (void) setMenuController:(id)n;
- (void) setLocalAspectRatio:(float)n;
- (BOOL) locked;
- (BOOL) fullyLocked;

@end
